var { ExtensionCommon } = ChromeUtils.import("resource://gre/modules/ExtensionCommon.jsm");

  const Cc = Components.classes;
  const Ci = Components.interfaces;

  /**
   * Get the incoming server for the given account id.
   *
   * @param {string} account
   *   the account id
   * @returns {Components.interfaces.nsIMsgAccountManager}
   *   a reference to the incoming server.
   */
    function getIncomingServer(account) {
      return Cc['@mozilla.org/messenger/account-manager;1']
        .getService(Ci.nsIMsgAccountManager)
        .getAccount(account)
        .incomingServer;
    }
  
    var myapi = class extends ExtensionCommon.ExtensionAPI {
    getAPI(context) {
        return {
                myapi: {
                    async getPrettyName(id) {
                      return await getIncomingServer(id).prettyName;
                    },

                    async getPassword(id) {
                      const server = getIncomingServer(id);

                      // in case the passwordPromptRequired attribute is true...
                      // ... thunderbird will take care on retrieving a valid password...
                      if (server.passwordPromptRequired === false) return await server.password;

                      return undefined;
                    },

                    async getUsername(id) {
                      if(getIncomingServer(id).realUsername !== undefined) return await getIncomingServer(id).realUsername;
                      else return await getIncomingServer(id).username;
                    },

                    async getHostname(id) {
                      if(getIncomingServer(id).realHostName !== undefined) return await getIncomingServer(id).realHostName;
                      else return await getIncomingServer(id).hostName;
                    }
                }
            }
        }
    };